ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.18 by root, Sat Mar 17 19:57:02 2007 UTC vs.
Revision 1.52 by root, Sat Aug 18 22:25:35 2007 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
14 15
15use Getopt::Long; 16use Getopt::Long;
16use Coro::Event; 17use Coro::Event;
17use AnyEvent; 18use AnyEvent;
18use IO::AIO (); 19use IO::AIO ();
19use File::Temp; 20use File::Temp;
20use Crossfire; 21use Crossfire;
21use Coro; 22use Coro;
22use Coro::AIO; 23use Coro::AIO;
24use Coro::Util;
23use POSIX (); 25use POSIX ();
24use Digest::MD5; 26use Digest::MD5;
27use Carp;
25use Storable; $Storable::canonical = 1; 28use Coro::Storable; $Storable::canonical = 1;
29
30$SIG{QUIT} = sub { Carp::cluck "QUIT" };
26 31
27sub usage { 32sub usage {
28 warn <<EOF; 33 warn <<EOF;
29Usage: cfutil [-v] [-q] [--force] [--cache] 34Usage: cfutil [-v] [-q] [--force] [--cache]
30 [--install-arch path] 35 [--install-arch path]
42my $CACHE = 0; 47my $CACHE = 0;
43my $FORCE; 48my $FORCE;
44my $TMPDIR = "/tmp/cfutil$$~"; 49my $TMPDIR = "/tmp/cfutil$$~";
45my $TMPFILE = "aaaa0"; 50my $TMPFILE = "aaaa0";
46 51
52our %COLOR = (
53 black => 0,
54 white => 1,
55 navy => 2,
56 red => 3,
57 orange => 4,
58 blue => 5,
59 darkorange => 6,
60 green => 7,
61 lightgreen => 8,
62 grey => 9,
63 brown => 10,
64 gold => 11,
65 tan => 12,
66);
67
47END { system "rm", "-rf", $TMPDIR } 68END { system "rm", "-rf", $TMPDIR }
48 69
49Event->signal (signal => "INT", cb => sub { exit 1 }); 70Event->signal (signal => "INT", cb => sub { exit 1 });
50Event->signal (signal => "TERM", cb => sub { exit 1 }); 71Event->signal (signal => "TERM", cb => sub { exit 1 });
51 72
68} 89}
69 90
70sub inst_maps($) { 91sub inst_maps($) {
71 my (undef, $path) = @_; 92 my (undef, $path) = @_;
72 93
73 print "installing '$path' to '$DATADIR/maps'\n"; 94 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
74 95
75 if (!-f "$path/regions") { 96 if (!-f "$path/regions") {
76 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 97 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
77 exit 1 unless $FORCE; 98 exit 1 unless $FORCE;
78 } 99 }
79 100
80 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded" 101 system $RSYNC, "-a", "--chmod=u=rwX,go=rX", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"
81 and die "map installation failed.\n"; 102 and die "map installation failed.\n";
82 103
83 print "maps installed successfully.\n"; 104 print "maps installed successfully.\n";
84} 105}
85 106
86{ 107{
87 our %PNG32; 108 our %ANIMINFO;
88 our %FACEINFO; 109 our %FACEINFO;
110 our %RESOURCE;
89 our @ARC; 111 our @ARC;
112 our %ARC;
90 our $TRS; 113 our $TRS;
91 our $NFILE; 114 our $NFILE;
92 our %ANIM; 115 our $PATH;
93 116
117 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
118
94 our (@png, @trs, @arc); # files we are interested in 119 our (@png, @trs, @arc, @res); # files we are interested in
95 120
96 sub commit_png { 121 sub commit_png($$$) {
97 my ($name, $data) = @_; 122 my ($name, $data, $T) = @_;
98 123
99 $PNG32{$name} = $data; 124 $FACEINFO{$name}{"data$T"} = $data;
100 $FACEINFO{$name} ||= {};
101 } 125 }
102 126
103 sub process_png { 127 sub process_png {
104 while (@png) { 128 while (@png) {
105 my $path = pop @png; 129 my ($path, $delete) = @{pop @png};
106 130
107 my $png; 131 my $png;
108 aio_lstat $path; 132 aio_lstat $path;
109 my ($size, $mtime) = (stat _)[7,9]; 133 my ($size, $mtime) = (stat _)[7,9];
110 134
111 if (0 > aio_load $path, $png) { 135 if (0 > aio_load $path, $png) {
112 warn "$path: $!, skipping.\n"; 136 warn "$path: $!, skipping.\n";
113 next; 137 next;
114 } 138 }
115 139
140 my $stem = $path;
141 my $T;
142
143 if ($stem =~ s/\.32x32\.png~?$//) {
144 $T = 32;
145 } elsif ($stem =~ s/\.64x64\.png~?$//) {
146 $T = 64;
147 } else {
148 warn "$path: weird filename, skipping.\n";
149 next;
150 }
151
116 # quickly extract width and height of the (necessarily PNG) image 152 # quickly extract width and height of the (necessarily PNG) image
117 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 153 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
118 warn "$path: not a recongized png file, skipping.\n"; 154 warn "$path: not a recognized png file, skipping.\n";
119 next; 155 next;
120 } 156 }
121 157
122 my ($w, $h) = unpack "NN", $1; 158 my ($w, $h) = unpack "NN", $1;
123
124 (my $face = $path) =~ s/^.*\///;
125 my $T = 32;
126
127 unless ($face =~ s/\.32x32\.png$//) {
128 warn "$path: weird filename, skipping.\n";
129 next;
130 }
131 159
132 if ($w < $T || $h < $T) { 160 if ($w < $T || $h < $T) {
133 warn "$path: too small ($w $h), skipping.\n"; 161 warn "$path: too small ($w $h), skipping.\n";
134 next; 162 next;
135 } 163 }
137 if ($w % $T || $h % $T) { 165 if ($w % $T || $h % $T) {
138 warn "$path: weird png size ($w $h), skipping.\n"; 166 warn "$path: weird png size ($w $h), skipping.\n";
139 next; 167 next;
140 } 168 }
141 169
170 unless ($path =~ /~$/) {
171 # possibly enlarge
172 if (0 > aio_stat "$stem.64x64.png") {
173 my $other = "$stem.64x64.png~";
174
175 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
176 fork_sub {
177 my $CROP;
178 my $SRC = "png:\Q$path\E";
179
180 # check if this is a wall. ultra-ugly. ultra-ultra-ugly.
181 if ($path =~ /^(.*\/wall\/.*_)([0-9A-F])(\.x11.*\.png)$/) {
182 my ($pfx, $dir, $sfx) = ($1, hex $2, $3);
183 #check for 0..F images to be sure(?) this is a wall
184 unless (grep { !-e sprintf "%s%X%s", $pfx, $_, $sfx } 0..15) {
185 # add a 4px border and add other images around it
186 $CROP = "-shave 8x8 +repage";
187
188 $w += 8;
189 $h += 8;
190
191 $SRC = "-size ${w}x${h} xc:transparent";
192 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
193
194 # 8 surrounding images
195 for (
196 # x y b r0 r1
197 [-1, -1, 0, 6],
198 [ 0, -1, 1, 10, 14],
199 [+1, -1, 0, 12],
200
201 [-1, 0, 8, 5, 7],
202 #
203 [+1, 0, 2, 5, 13],
204
205 [-1, +1, 0, 3],
206 [ 0, +1, 4, 10, 11],
207 [+1, +1, 0, 9],
208 ) {
209 my ($x, $y, $d, $r0, $r1) = @$_;
210 $SRC .= sprintf " png:%s%X%s -geometry %+d%+d -composite",
211 "\Q$pfx",
212 ($dir & $d) ? $r1 : $r0,
213 "\Q$sfx",
214 $x * ($w - 8) + 4,
215 $y * ($h - 8) + 4;
216 }
217 }
218 }
219
220 system "convert -depth 8 $SRC rgba:-"
221 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
222 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
223 and die "convert/cfhq2xa pipeline error: status $? ($!)";
224 system $OPTIPNG, "-i0", "-q", "$other~";
225 die "$other~ has zero size, aborting." unless -s "$other~";
226 rename "$other~", $other;
227 };
228 }
229
230 push @png, [$other, !$CACHE];
231 }
232
233 # possibly scale down
234 if (0 > aio_stat "$stem.32x32.png") {
235 my $other = "$stem.32x32.png~";
236
237 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
238 fork_sub {
239 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
240 system $OPTIPNG, "-i0", "-q", "$other~";
241
242 # reduce smoothfaces >10000 bytes
243 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
244 my $ncolor = 256;
245 while () {
246 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
247 system $OPTIPNG, "-i0", "-q", "$other~~";
248 last if 10000 > -s "$other~~";
249 $ncolor = int $ncolor * 0.9;
250 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
251 }
252
253 printf "reduced %s from %d to %d bytes using %d colours.\n",
254 $other, -s "$other~", -s "$other~~", $ncolor
255 if $VERBOSE >= 2;
256 rename "$other~~", "$other~";
257 }
258
259 die "$other~ has zero size, aborting." unless -s "$other~";
260 rename "$other~", $other;
261 };
262 }
263
264 #warn "scaled down $path to $other\n";#d#
265 push @png, [$other, !$CACHE];
266 }
267 }
268
269 (my $face = $stem) =~ s/^.*\///;
270
271 # split all bigfaces, but avoid smoothfaces (*_S)
142 if (($w > $T || $h > $T) && $face !~ /_S\./) { 272 if (($w > $T || $h > $T) && $face !~ /_S\./) {
143 # split 273 # split
144 my @tile; 274 my @tile;
145 for my $x (0 .. (int $w / $T) - 1) { 275 for my $x (0 .. (int $w / $T) - 1) {
146 for my $y (0 .. (int $h / $T) - 1) { 276 for my $y (0 .. (int $h / $T) - 1) {
160 ( 290 (
161 "(", 291 "(",
162 "+clone", 292 "+clone",
163 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 293 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
164 "+repage", 294 "+repage",
295 -quality => "00",
165 -write => "png:$_->[2]~", 296 -write => "png32:$_->[2]~",
166 "+delete", 297 "+delete",
167 ")", 298 ")",
168 ) 299 )
169 } @todo), 300 } @todo),
170 "null:"; 301 "null:";
174 close $convert; 305 close $convert;
175 306
176 # pass 2, optimise, and rename 307 # pass 2, optimise, and rename
177 for (@todo) { 308 for (@todo) {
178 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 309 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
310 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
179 rename "$_->[2]~", $_->[2]; 311 rename "$_->[2]~", $_->[2];
180 } 312 }
181 }; 313 };
182 } 314 }
183 315
187 319
188 if (0 > aio_load $file, $tile) { 320 if (0 > aio_load $file, $tile) {
189 die "$path: unable to read tile +$x+$y, aborting.\n"; 321 die "$path: unable to read tile +$x+$y, aborting.\n";
190 } 322 }
191 IO::AIO::aio_unlink $file unless $CACHE; 323 IO::AIO::aio_unlink $file unless $CACHE;
192 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 324 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
193 } 325 }
194 } else { 326 } else {
195 # use as-is (either small, use smooth) 327 # use as-is (either small, use smooth)
196 commit_png $face, $png; 328 commit_png $face, $png, $T;
197 } 329 }
330
331 aio_unlink $path if $delete;
198 } 332 }
199 } 333 }
200 334
201 sub process_arc { 335 sub process_arc {
202 while (@arc) { 336 while (@arc) {
206 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 340 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
207 341
208 my $arc = read_arch "$dir/$file"; 342 my $arc = read_arch "$dir/$file";
209 for my $o (values %$arc) { 343 for my $o (values %$arc) {
210 push @ARC, $o; 344 push @ARC, $o;
345 for (my $m = $o; $m; $m = $m->{more}) {
346 $ARC{$m->{_name}} = $m;
347 }
211 348
212 $o->{editor_folder} = $dir; 349 $o->{editor_folder} = $dir;
213 350
214 my $visibility = delete $o->{visibility}; 351 my $visibility = delete $o->{visibility};
215 my $magicmap = delete $o->{magicmap}; 352 my $magicmap = delete $o->{magicmap};
226 my $x = $o->{x} - $dx; 363 my $x = $o->{x} - $dx;
227 my $y = $o->{y} - $dy; 364 my $y = $o->{y} - $dy;
228 365
229 my $ext = $x|$y ? "+$x+$y" : ""; 366 my $ext = $x|$y ? "+$x+$y" : "";
230 367
231 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/; 368 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
232 369
233 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 370 $visibility = delete $o->{visibility} if exists $o->{visibility};
234 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 371 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
235 372
236 my $anim = delete $o->{anim}; 373 my $anim = delete $o->{anim};
237 374
238 if ($anim) { 375 if ($anim) {
376 # possibly add $ext to the animation name to avoid
377 # the need to specify archnames for all parts
378 # of a multipart archetype.
239 $o->{animation} = "$o->{_name}"; 379 $o->{animation} = "$o->{_name}";
380 my $facings = 1;
381 my @frames;
240 382
241 for (@$anim) { 383 for (@$anim) {
242 $_ .= $ext unless /^facings\s|^blank.x11$|^empty.x11$/; 384 if (/^facings\s+(\d+)/) {
385 $facings = $1*1;
386 } elsif (/^blank.x11$|^empty.x11$/) {
387 push @frames, $_;
388 } else {
389 push @frames, "$_$ext";
390 }
243 } 391 }
244 392
245 $ANIM{"$o->{_name}$ext"} = 393 $ANIMINFO{$o->{animation}} = {
246 join "", map "$_\n", 394 facings => $facings,
247 "anim $o->{_name}", 395 frames => \@frames,
248 @$anim, 396 };
249 "mina";
250 } 397 }
251 398
252 for my $face ($o->{face} || (), @{$anim || []}) { 399 for my $face ($o->{face} || (), @{$anim || []}) {
253 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 400 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/;
254 401
257 $info->{visibility} = $visibility if defined $visibility; 404 $info->{visibility} = $visibility if defined $visibility;
258 $info->{magicmap} = $magicmap if defined $magicmap; 405 $info->{magicmap} = $magicmap if defined $magicmap;
259 } 406 }
260 407
261 if (my $smooth = delete $o->{smoothface}) { 408 if (my $smooth = delete $o->{smoothface}) {
262 my ($face, $smooth) = split /\s+/, $smooth; 409 my %kv =split /\s+/, $smooth;
263 # skip empty_S.x11, it seems to server no purpose whatsoever 410 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
264 # but increases bandwidth demands and worse. 411 while (my ($face, $smooth) = each %kv) {
265 unless ($smooth eq "empty_S.x11") {
266 $FACEINFO{$face}{smooth} = $smooth; 412 $FACEINFO{$face}{smooth} = $smooth;
413 $FACEINFO{$face}{smoothlevel} = $level;
267 } 414 }
268 } 415 }
269 } 416 }
270 } 417 }
271 } 418 }
284 431
285 $TRS .= $trs; 432 $TRS .= $trs;
286 } 433 }
287 } 434 }
288 435
436 my %FILECACHE;
437
438 sub load_cached($;$) {
439 unless (exists $FILECACHE{$_[0]}) {
440 my $data;
441 if (0 < aio_load $_[0], $data) {
442 if ($_[1]) {
443 $data = eval { $_[1]->($data) };
444 warn "$_[0]: $@" if $@;
445 }
446 }
447
448 $FILECACHE{$_[0]} = $data;
449 }
450
451 $FILECACHE{$_[0]}
452 }
453
454 sub process_res {
455 while (@res) {
456 my ($dir, $file, $type) = @{pop @res};
457
458 my $data;
459 aio_load "$dir/$file", $data;
460
461 my $meta = load_cached "$dir/meta", sub { JSON::XS::from_json shift };
462
463 next if $meta && !exists $meta->{$file};
464
465 $meta = {
466 %{ $meta->{"" } || {} },
467 %{ $meta->{$file} || {} },
468 };
469
470 if ($meta->{license} =~ s/^#//) {
471 $meta->{license} = ({
472 "pd" => "Public Domain",
473 "gpl" => "GNU General Public License, version 3.0 or any later",
474 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
475 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.5/",
476 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
477 })->{$meta->{license}}
478 || warn "$dir/$file: license tag '$meta->{license}' not found.";
479 }
480
481 $file =~ s/\.res$//;
482 $file =~ s/\.(ogg|wav|jpg|png)$//;
483
484 substr $dir, 0, 1 + length $PATH, "";
485
486 $RESOURCE{"$dir/$file"} = {
487 type => (delete $meta->{type}) || $type,
488 data => $data,
489 chksum => (Digest::MD5::md5 $data),
490 %$meta ? (meta => $meta) : (),
491 };
492 }
493 }
494
289 sub find_files; 495 sub find_files;
290 sub find_files { 496 sub find_files {
291 my ($path) = @_; 497 my ($path) = @_;
292 498
293 IO::AIO::aioreq_pri 4; 499 IO::AIO::aioreq_pri 4;
295 my ($dirs, $nondirs) = @_; 501 my ($dirs, $nondirs) = @_;
296 502
297 find_files "$path/$_" 503 find_files "$path/$_"
298 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 504 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
299 505
506 my $dir = $path;
507 substr $dir, 0, 1 + length $PATH, "";
508
300 for my $file (@$nondirs) { 509 for my $file (@$nondirs) {
510 if ($dir =~ /^music(?:\/|$)/) {
511 push @res, [$path, $file, 3] # FT_MUSIC
512 if $file =~ /\.(ogg)$/;
513
514 } elsif ($dir =~ /^sound(?:\/|$)/) {
515 push @res, [$path, $file, 5] # FT_SOUND
516 if $file =~ /\.(wav|ogg)$/;
517
518 } elsif ($dir =~ /^res(?:\/|$)/) {
519 push @res, [$path, $file, 0] # FT_FACE
520 if $file =~ /\.(jpg|png)$/;
521 push @res, [$path, $file, 7] # FT_RSRC
522 if $file =~ /\.(res)$/;
523
301 if ($file =~ /\.png$/) { 524 } elsif ($file =~ /\.png$/) {
302 push @png, "$path/$file"; 525 push @png, ["$path/$file", 0];
526
303 } elsif ($file =~ /\.trs$/) { 527 } elsif ($file =~ /\.trs$/) {
304 push @trs, [$path, $file]; 528 push @trs, [$path, $file];
529
305 } elsif ($file =~ /\.arc$/) { 530 } elsif ($file =~ /\.arc$/) {
306 push @arc, [$path, $file]; 531 push @arc, [$path, $file];
532
307 } else { 533 } else {
308 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 534 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
309 } 535 }
310 } 536 }
311 }; 537 };
312 } 538 }
313 539
314 sub inst_arch($) { 540 sub inst_arch($) {
315 my (undef, $path) = @_; 541 my (undef, $path) = @_;
316 542
543 $PATH = $path;
544
545 print "\n",
317 print "installing '$path' to '$DATADIR'\n"; 546 "Installing '$path' to '$DATADIR'\n",
547 "\n",
548 "This can take a long time if you run this\n",
549 "for the first time or do not use --cache.\n",
550 "\n",
551 "Unless you run verbosely, all following warning\n",
552 "or error messages indicate serious problems.\n",
553 "\n";
318 554
319 if (!-d "$path/treasures") { 555 if (!-d "$path/treasures") {
320 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 556 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
321 exit 1 unless $FORCE; 557 exit 1 unless $FORCE;
322 } 558 }
323 559
324 find_files $path; 560 find_files $path;
325 IO::AIO::flush; 561 IO::AIO::flush;
326 562
327 $_->join for ( 563 $_->join for (
328 (async \&process_png), (async \&process_png), 564 # four png crunchers work fine for my 2x smp machine
565 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png),
329 (async \&process_trs), (async \&process_trs), 566 (async \&process_trs), (async \&process_trs),
330 (async \&process_arc), (async \&process_arc), 567 (async \&process_arc), (async \&process_arc),
568 (async \&process_res), (async \&process_res),
331 ); 569 );
332 570
333 { 571 {
334 open my $fh, ">:utf8", "$DATADIR/animations~" 572 # remove path prefix from editor_folder
335 or die "$DATADIR/animations~: $!"; 573 substr $_->{editor_folder}, 0, 1 + length $path, ""
336 print $fh join "", map $ANIM{$_}, sort keys %ANIM 574 for values %ARC;
575
576 # resolve inherit
577 while () {
578 my $progress;
579 my $loop;
580
581 for my $o (values %ARC) {
582 if (my $other = $o->{inherit}) {
583 if (my $s = $ARC{$other}) {
584 if ($s->{inherit}) {
585 $loop = $s;
586 } else {
587 delete $o->{inherit};
588 my %s = %$s;
589 delete @s{qw(_name more name name_pl)};
590 %$o = ( %s, %$o );
591 ++$progress;
592 }
593 } else {
594 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
595 delete $ARC{$o->{_name}};
596 }
597 }
598 }
599
600 unless ($progress) {
601 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
602 if $loop;
603
604 last;
605 }
337 } 606 }
338 607
339 { 608 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
609 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
610
340 open my $fh, ">:utf8", "$DATADIR/archetypes~" 611 open my $fh, ">:utf8", "$DATADIR/archetypes~"
341 or die "$DATADIR/archetypes~: $!"; 612 or die "$DATADIR/archetypes~: $!";
342 substr $_->{editor_folder}, 0, 1 + length $path, "" for @ARC; 613 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
343 print $fh Crossfire::archlist_to_string \@ARC;
344 } 614 }
345 615
346 { 616 {
347 open my $fh, ">:utf8", "$DATADIR/treasures~" 617 open my $fh, ">:utf8", "$DATADIR/treasures~"
348 or die "$DATADIR/treasures~: $!"; 618 or die "$DATADIR/treasures~: $!";
349 print $fh $TRS; 619 print $fh $TRS;
350 } 620 }
351 621
352 { 622 {
353 while (my ($k, $v) = each %FACEINFO) { 623 while (my ($k, $v) = each %FACEINFO) {
354 $v->{data32} ||= delete $PNG32{$k};
355 }
356
357 while (my ($k, $v) = each %FACEINFO) {
358 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n"; 624 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
625 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
626
627 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
628 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
359 629
360 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 630 $v->{chksum32} = Digest::MD5::md5 $v->{data32};
631 $v->{chksum64} = Digest::MD5::md5 $v->{data64};
632
633 if (my $magicmap = $v->{magicmap}) {
634 $magicmap =~ y/A-Z_\-/a-z/d;
635 $v->{magicmap} = $COLOR{$magicmap};
361 } 636 }
637 }
362 638
363 open my $fh, ">:perlio", "$DATADIR/faces~" 639 open my $fh, ">:perlio", "$DATADIR/facedata~"
364 or die "$DATADIR/faces~: $!"; 640 or die "$DATADIR/facedata~: $!";
365 641
366 $FACEINFO{""} = { version => 1}; 642 print $fh freeze {
367 print $fh Storable::nfreeze \%FACEINFO; 643 version => 2,
644 faceinfo => \%FACEINFO,
645 animinfo => \%ANIMINFO,
646 resource => \%RESOURCE,
368 } 647 };
648 }
369 649
370 for (qw(archetypes faces animations treasures)) { 650 for (qw(archetypes facedata treasures)) {
371 chmod 0644, "$DATADIR/$_~"; 651 chmod 0644, "$DATADIR/$_~";
372 rename "$DATADIR/$_~", "$DATADIR/$_" 652 rename "$DATADIR/$_~", "$DATADIR/$_"
373 or die "$DATADIR/$_: $!"; 653 or die "$DATADIR/$_: $!";
374 } 654 }
375 655

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines